; Creates a new object with entmakex
(entmakex '((0 . "LINE")
            (10 0.0 0.0 0.0) ; Start point
            (11 5.0 5.0 0.0) ; End point
           )
)


;|-----------------------------------------------------------------------|;


; Helper function used to create an object without using the commands
(defun addObj (objType / newObj)
  (setq newObj
        (cond
            ((= (strcase objType) "LINE")
                (entmakex '((0 . "LINE")
                            (10 0.0 0.0 0.0) ; Start point
                            (11 1.0 1.0 1.0) ; End point
                           )
                )
            )
            ((= (strcase objType) "CIRCLE")
                (entmakex '((0 . "CIRCLE")
                            (10 0.0 0.0 0.0) ; Center point
                            (40 . 1.0)       ; Radius
                           )
                )
            )
            ((= (strcase objType) "LAYER")
                (entmakex (list (cons 0 "LAYER")
                                (cons 100 "AcDbSymbolTableRecord")
                                (cons 100 "AcDbLayerTableRecord")
                                (cons 2 "OBJ")        ; Name
                                (cons 70 0)           ; State
                                (cons 62 7)           ; Color
                                (cons 6 "Continuous") ; Linetype
                          )
                )
            )
        )
  )
)

; Create a new layer
(addObj "Layer")

; Create a new line
(addObj "Line")

; Create a new circle
(addObj "Circle")


;|-----------------------------------------------------------------------|;


; Changes the radius of a selected circle from 1 to 2
(defun c:ChangeRadius ( / )
  (setq ent (car (entsel "\nSelect a circle: ")))
  (setq ed (entget ent))

  ; Change the circle's radius to 2
  (setq ed 
    (subst (cons 40 2.0)
      (assoc 40 ed)
      ed
    ) 
  )

  ; Modify and update the object
  (entmod ed)
  (entupd ent)
 (princ)
)

; Changes the radius of a selected circle from 1 to 2
(defun c:ChangeRadius ( / )
  (setq ent (car (entsel "\nSelect a circle: ")))
  (setpropertyvalue ent "radius" 2)
 (princ)
)


;|-----------------------------------------------------------------------|;


; Creates and modifies objects with the use of the addObj helper function
(defun c:newObjects ( / layEnt newObj)
  ; Create a new Layer named Const if it does not exist
  (if (= (setq layEnt (tblobjname "layer" "Const")) nil)
    (progn
      (setq layEnt (addobj "Layer"))
      
      ; Update the new layers name
      (setpropertyvalue layEnt "Name" "Const")

      ; Set the color of the new layer
      ; Color can be ACI (6), true color (125,125,125),
      ; or color book (PANTONE+ CMYK Coated,PANTONE P 1-3 C)
      (setpropertyvalue layEnt "Color" "231,18,18")

      ; Set the layer so it cannot be plotted
      (setpropertyvalue layEnt "IsPlottable" 0)
    )
  )

  ; Create a new line
  (setq newObj (addObj "Line"))

  ; Set the start and end point
  (setpropertyvalue newObj "StartPoint" '(0.0 0.0 0.0))
  (setpropertyvalue newObj "EndPoint" '(5.0 5.0 0.0))

  ; Change the layer of the new line
  (setpropertyvalue newObj "LayerID" layEnt)

  ; Create a new circle
  (setq newObj (addObj "Circle"))

  ; Set the start and end point
  (setpropertyvalue newObj "Center" '(5.0 5.0 0.0))

  ; Change the layer of the new line
  (setpropertyvalue newObj "LayerID" layEnt)

 (princ)
)
